Module Module1
    Sub text()
        Console.Clear()
        Console.WriteLine("Эта программа проверяет правильность")
        Console.WriteLine("расположения круглых скобок в выражении")

    End Sub
    Function Amount(ByVal line As String, ByVal character As String) As Integer
        Dim n As Integer
        Do Until line.IndexOf(character) = -1
            line = line.Substring(line.IndexOf(character) + 1)
            n += 1
        Loop
        Return n
    End Function
    Function Position(ByRef line As String, ByVal character As String) As Integer
        Dim n As Integer
        n = line.IndexOf(character)
        line = line.Substring(n + 1)
        Return n
    End Function
    Sub Main()
        Console.WriteLine("Эта программа проверяет правильность")
        Console.WriteLine("расположения круглых скобок в выражении")
        Do
            Dim LineLeft As String = Console.ReadLine()
            Dim LineRight As String = LineLeft
            If Amount(LineLeft, "(") <> Amount(LineRight, ")") Then
                Console.WriteLine(" Различное количество скобок")
                Console.WriteLine("Нажмите Enter чтобы продолжить работу")
                Console.ReadLine() : text()
            ElseIf Amount(LineLeft, "(") = 0 And Amount(LineRight, ")") = 0 Then
                Console.WriteLine(" В строке нет скобок")
                Console.WriteLine("Нажмите Enter чтобы продолжить работу")
                Console.ReadLine() : text()
            ElseIf Amount(LineLeft, "(") = Amount(LineRight, ")") Then
                Dim number As Integer = Amount(LineLeft, "(")
                Dim Verdict As Boolean = True
                For i As Integer = 1 To number
                    If Position(LineLeft, "(") > Position(LineRight, ")") Then
                        Verdict = False
                    Else
                    End If
                Next i
                If Verdict = False Then
                    Console.WriteLine(" Неправильное расположение скобок")
                    Console.WriteLine("Нажмите Enter чтобы продолжить работу")
                    Console.ReadLine() : text()
                Else : Console.WriteLine(" Расположение скобок корректно")
                    Console.WriteLine("Нажмите Enter чтобы продолжить работу")
                    Console.ReadLine()
                    text()
                End If
            End If
        Loop
    End Sub

End Module
